<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__profile__functions__calculation" kind="group">
    <compoundname>group_profile_functions_calculation</compoundname>
    <title>Calculation Functions</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__profile__functions__calculation_1gadeaf5617ad8fe9fa2cfb2c72e19bf488" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__profile__enums_1ga7d980aa8f4c0159ccc47a973dd543e02">cy_en_profile_status_t</ref></type>
        <definition>cy_en_profile_status_t Cy_Profile_GetRawCount</definition>
        <argsstring>(cy_stc_profile_ctr_ptr_t ctrAddr, uint64_t *result)</argsstring>
        <name>Cy_Profile_GetRawCount</name>
        <param>
          <type><ref kindref="member" refid="group__group__profile__data__structures_1gac954b1f2e2b8fc00b15f89c0b1fe372e">cy_stc_profile_ctr_ptr_t</ref></type>
          <declname>ctrAddr</declname>
        </param>
        <param>
          <type>uint64_t *</type>
          <declname>result</declname>
        </param>
        <briefdescription>
<para>Reports the raw count value for a specified counter. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ctrAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>The handle to the assigned counter, (returned by calling <ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref>).</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>result</parametername>
</parameternamelist>
<parameterdescription>
<para>Output parameter used to write in the result.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />The<sp />raw<sp />count<sp />value<sp />of<sp />profile<sp />counter<sp />assigned<sp />to<sp />position<sp />#0</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />in<sp />the<sp />previous<sp />profiling<sp />window<sp />needs<sp />to<sp />be<sp />read.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1gad8b4c8660845665052ffc891d9b1cd50">Cy_Profile_StartProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />some<sp />activity...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />ready<sp />to<sp />read<sp />the<sp />results<sp />of<sp />the<sp />counter<sp />values,<sp />stop<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1ga4a4a1151a6c68338ab316b8119ae91ec">Cy_Profile_StopProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Variable<sp />for<sp />storing<sp />the<sp />raw<sp />count<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint64_t<sp />rawCnt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />the<sp />raw<sp />count<sp />value<sp />of<sp />profile<sp />counter<sp />#0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__profile__enums_1gga7d980aa8f4c0159ccc47a973dd543e02a9328da8e423851a200dc18bceea5b54c">CY_PROFILE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__profile__functions__calculation_1gadeaf5617ad8fe9fa2cfb2c72e19bf488">Cy_Profile_GetRawCount</ref>(cntHandle[0],<sp />&amp;rawCnt))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="371" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="356" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="509" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__profile__functions__calculation_1ga2679f0e6dbd57afa6f5edff6721757ed" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__profile__enums_1ga7d980aa8f4c0159ccc47a973dd543e02">cy_en_profile_status_t</ref></type>
        <definition>cy_en_profile_status_t Cy_Profile_GetWeightedCount</definition>
        <argsstring>(cy_stc_profile_ctr_ptr_t ctrAddr, uint64_t *result)</argsstring>
        <name>Cy_Profile_GetWeightedCount</name>
        <param>
          <type><ref kindref="member" refid="group__group__profile__data__structures_1gac954b1f2e2b8fc00b15f89c0b1fe372e">cy_stc_profile_ctr_ptr_t</ref></type>
          <declname>ctrAddr</declname>
        </param>
        <param>
          <type>uint64_t *</type>
          <declname>result</declname>
        </param>
        <briefdescription>
<para>Reports the count value for a specified counter, multiplied by the weight factor for that counter. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ctrAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>The handle to the assigned counter, (returned by calling <ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref>).</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>result</parametername>
</parameternamelist>
<parameterdescription>
<para>Output parameter used to write in the result.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />The<sp />weighted<sp />count<sp />value<sp />of<sp />the<sp />profile<sp />counter<sp />assigned<sp />to<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />position<sp />#0<sp />in<sp />the<sp />previous<sp />profiling<sp />window<sp />needs<sp />to<sp />be<sp />read.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1gad8b4c8660845665052ffc891d9b1cd50">Cy_Profile_StartProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />ready<sp />to<sp />read<sp />the<sp />results<sp />of<sp />the<sp />counter<sp />values,<sp />stop<sp />the<sp />profiling<sp />window.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1ga4a4a1151a6c68338ab316b8119ae91ec">Cy_Profile_StopProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Variable<sp />for<sp />storing<sp />the<sp />weighted<sp />count<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint64_t<sp />weightedCnt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />the<sp />weighted<sp />count<sp />value<sp />of<sp />profile<sp />counter<sp />#0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__profile__enums_1gga7d980aa8f4c0159ccc47a973dd543e02a9328da8e423851a200dc18bceea5b54c">CY_PROFILE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__profile__functions__calculation_1ga2679f0e6dbd57afa6f5edff6721757ed">Cy_Profile_GetWeightedCount</ref>(cntHandle[0],<sp />&amp;weightedCnt))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="404" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="392" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="510" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__profile__functions__calculation_1gaf7064fd5a7d413a42fb9d3053cf8f8ea" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint64_t</type>
        <definition>uint64_t Cy_Profile_GetSumWeightedCounts</definition>
        <argsstring>(cy_stc_profile_ctr_ptr_t ptrsArray[], uint32_t numCounters)</argsstring>
        <name>Cy_Profile_GetSumWeightedCounts</name>
        <param>
          <type><ref kindref="member" refid="group__group__profile__data__structures_1gac954b1f2e2b8fc00b15f89c0b1fe372e">cy_stc_profile_ctr_ptr_t</ref></type>
          <declname>ptrsArray</declname>
          <array>[]</array>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>numCounters</declname>
        </param>
        <briefdescription>
<para>Reports the weighted sum result of the first n number of counter count values starting from the specified profile counter data structure base address. </para>        </briefdescription>
        <detaileddescription>
<para>Each count value is multiplied by its weighing factor before the summing operation is performed.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ptrsArray</parametername>
</parameternamelist>
<parameterdescription>
<para>Base address of the profile counter data structure</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>numCounters</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of measured counters in ptrsArray[]</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The weighted sum of the specified counters</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />The<sp />weighted<sp />average<sp />of<sp />assigned<sp />profile<sp />counters<sp />in<sp />positions</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#0<sp />to<sp />#5<sp />in<sp />the<sp />previous<sp />profiling<sp />window<sp />needs<sp />to<sp />be<sp />read.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1gad8b4c8660845665052ffc891d9b1cd50">Cy_Profile_StartProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />ready<sp />to<sp />read<sp />the<sp />results<sp />of<sp />the<sp />counter<sp />values,<sp />stop<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1ga4a4a1151a6c68338ab316b8119ae91ec">Cy_Profile_StopProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Energy<sp />limit<sp />(example)<sp />of<sp />a<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint64_t<sp />energyLimit<sp />=<sp /><sp />0x00020000UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />the<sp />weighted<sp />average<sp />of<sp />assigned<sp />profile<sp />counters<sp />in<sp />positions<sp />#0<sp />to<sp />#5<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint64_t<sp />weightedAvg<sp />=<sp /><ref kindref="member" refid="group__group__profile__functions__calculation_1gaf7064fd5a7d413a42fb9d3053cf8f8ea">Cy_Profile_GetSumWeightedCounts</ref>(&amp;cntHandle[0],<sp />6UL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(weightedAvg<sp />&gt;<sp />energyLimit)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />energy<sp />consumption<sp />is<sp />more<sp />than<sp />expected<sp />for<sp />this<sp />profiling<sp />window.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Take<sp />appropriate<sp />measures<sp />to<sp />reduce<sp />the<sp />energy<sp />consumption.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="450" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="427" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="511" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>